# generated by datamodel-codegen:
#   filename:  manifest_cloud_v1.json

from __future__ import annotations

from enum import Enum
from typing import Any, Dict, List, Literal, Optional, Union
from uuid import UUID

from pydantic import ConfigDict, Field, StringConstraints
from typing_extensions import Annotated

from collate_dbt_artifacts_parser.parsers.base import BaseParserModel


class Metadata(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    dbt_schema_version: Optional[str] = None
    dbt_version: Optional[str] = '1.10.0a1'
    generated_at: Optional[str] = None
    invocation_id: Optional[str] = None
    env: Optional[Dict[str, str]] = None
    project_name: Optional[str] = Field(None,
                                        description='Name of the root project')
    project_id: Optional[str] = Field(
        None,
        description=
        'A unique identifier for the project, hashed from the project name',
    )
    user_id: Optional[UUID] = Field(
        None, description='A unique identifier for the user')
    send_anonymous_usage_stats: Optional[bool] = Field(
        None,
        description=
        'Whether dbt is configured to send anonymous usage statistics')
    adapter_type: Optional[str] = Field(
        None, description='The type name of the adapter')


class Checksum(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    checksum: str


class PostHookItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    sql: str
    transaction: Optional[bool] = True
    index: Optional[int] = None


class PreHookItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    sql: str
    transaction: Optional[bool] = True
    index: Optional[int] = None


class OnConfigurationChange(Enum):
    apply = 'apply'
    continue_ = 'continue'
    fail = 'fail'


class Docs(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    show: Optional[bool] = True
    node_color: Optional[str] = None


class Contract(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Config(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'seed'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    delimiter: Optional[str] = ','
    quote_columns: Optional[bool] = None


class Type(Enum):
    check = 'check'
    not_null = 'not_null'
    unique = 'unique'
    primary_key = 'primary_key'
    foreign_key = 'foreign_key'
    custom = 'custom'


class Constraint(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class GranularityEnum(Enum):
    nanosecond = 'nanosecond'
    microsecond = 'microsecond'
    millisecond = 'millisecond'
    second = 'second'
    minute = 'minute'
    hour = 'hour'
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class Columns(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DependsOn(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None


class ResourceType(Enum):
    model = 'model'
    analysis = 'analysis'
    test = 'test'
    snapshot = 'snapshot'
    operation = 'operation'
    seed = 'seed'
    rpc = 'rpc'
    sql_operation = 'sql_operation'
    doc = 'doc'
    source = 'source'
    macro = 'macro'
    exposure = 'exposure'
    metric = 'metric'
    group = 'group'
    saved_query = 'saved_query'
    semantic_model = 'semantic_model'
    unit_test = 'unit_test'
    fixture = 'fixture'


class ConfigItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem] = None


class Node(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['seed']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config] = Field(None, title='SeedConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    root_path: Optional[str] = None
    depends_on: Optional[DependsOn] = Field(None, title='MacroDependsOn')
    defer_relation: Optional[DeferRelationItem] = None


class Config1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint1]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Ref(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    package: Optional[str] = None
    version: Optional[Union[str, float]] = None


class DependsOn1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None
    nodes: Optional[List[str]] = None


class ExtraCte(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    id: str
    sql: str


class Contract3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Node1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['analysis']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config1] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns1]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn1] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract3] = Field(None, title='Contract')


class Config2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field('dbt_test__audit', alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'test'
    severity: Optional[Annotated[
        str,
        StringConstraints(pattern=r'^([Ww][Aa][Rr][Nn]|[Ee][Rr][Rr][Oo][Rr])$'),
    ]] = 'ERROR'
    store_failures: Optional[bool] = None
    store_failures_as: Optional[str] = None
    where: Optional[str] = None
    limit: Optional[int] = None
    fail_calc: Optional[str] = 'count(*)'
    warn_if: Optional[str] = '!= 0'
    error_if: Optional[str] = '!= 0'


class Constraint2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint2]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Node2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['test']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config2] = Field(None, title='TestConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns2]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn1] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract3] = Field(None, title='Contract')


class Contract5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Config3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract5] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint3]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Node3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['operation']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config3] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns3]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn1] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract6] = Field(None, title='Contract')
    index: Optional[int] = None


class Contract7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Access(Enum):
    private = 'private'
    protected = 'protected'
    public = 'public'


class Config4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract7] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    access: Optional[Access] = 'protected'


class Constraint4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint4]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Constraint5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None
    columns: Optional[List[str]] = None


class Contract9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class ConfigItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract9] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem1] = None


class CustomGranularity(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    column_name: Optional[str] = None


class TimeSpineItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    standard_granularity_column: str
    custom_granularities: Optional[List[CustomGranularity]] = None


class Period(Enum):
    minute = 'minute'
    hour = 'hour'
    day = 'day'


class DependsOn5(Enum):
    all = 'all'
    any = 'any'


class BuildAfter(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = 0
    period: Optional[Period] = 'hour'
    depends_on: Optional[DependsOn5] = 'any'


class Freshnes(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    build_after: Optional[BuildAfter] = Field(None, title='ModelBuildAfter')


class Node4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['model']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config4] = Field(None, title='ModelConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns4]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn1] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract8] = Field(None, title='Contract')
    access: Optional[Access] = 'protected'
    constraints: Optional[List[Constraint5]] = None
    version: Optional[Union[str, float]] = None
    latest_version: Optional[Union[str, float]] = None
    deprecation_date: Optional[str] = None
    defer_relation: Optional[DeferRelationItem1] = None
    primary_key: Optional[List[str]] = None
    time_spine: Optional[TimeSpineItem] = None
    freshness: Optional[Freshnes] = None


class Config5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract9] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint6]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DependsOn6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None
    nodes: Optional[List[str]] = None


class Contract11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Node5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['sql_operation']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config5] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns5]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn6] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract11] = Field(None, title='Contract')


class Config6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field('dbt_test__audit', alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'test'
    severity: Optional[Annotated[
        str,
        StringConstraints(pattern=r'^([Ww][Aa][Rr][Nn]|[Ee][Rr][Rr][Oo][Rr])$'),
    ]] = 'ERROR'
    store_failures: Optional[bool] = None
    store_failures_as: Optional[str] = None
    where: Optional[str] = None
    limit: Optional[int] = None
    fail_calc: Optional[str] = 'count(*)'
    warn_if: Optional[str] = '!= 0'
    error_if: Optional[str] = '!= 0'


class Constraint7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint7]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class TestMetadata(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: Optional[str] = 'test'
    kwargs: Optional[Dict[str, Any]] = None
    namespace: Optional[str] = None


class Node6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['test']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config6] = Field(None, title='TestConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns6]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn6] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract11] = Field(None, title='Contract')
    column_name: Optional[str] = None
    file_key_name: Optional[str] = None
    attached_node: Optional[str] = None
    test_metadata: Optional[TestMetadata] = Field(None, title='TestMetadata')


class Contract13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class SnapshotMetaColumnNames(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    dbt_valid_to: Optional[str] = None
    dbt_valid_from: Optional[str] = None
    dbt_scd_id: Optional[str] = None
    dbt_updated_at: Optional[str] = None
    dbt_is_deleted: Optional[str] = None


class Config7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'snapshot'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract13] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    strategy: Optional[str] = None
    target_schema: Optional[str] = None
    target_database: Optional[str] = None
    updated_at: Optional[str] = None
    check_cols: Optional[Union[str, List[str]]] = None
    snapshot_meta_column_names: Optional[SnapshotMetaColumnNames] = Field(
        None, title='SnapshotMetaColumnNames')
    dbt_valid_to_current: Optional[str] = None


class Constraint8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint8]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract14(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Contract15(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class ConfigItem2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    contract: Optional[Contract15] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem2] = None


class Node7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['snapshot']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Config7 = Field(..., title='SnapshotConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns7]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn6] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract14] = Field(None, title='Contract')
    defer_relation: Optional[DeferRelationItem2] = None


class Quoting(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[bool] = None
    schema_: Optional[bool] = Field(None, alias='schema')
    identifier: Optional[bool] = None
    column: Optional[bool] = None


class PeriodEnum(Enum):
    minute = 'minute'
    hour = 'hour'
    day = 'day'


class WarnAfterItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = None
    period: Optional[PeriodEnum] = None


class ErrorAfterItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = None
    period: Optional[PeriodEnum] = None


class Freshnes1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    warn_after: Optional[WarnAfterItem] = None
    error_after: Optional[ErrorAfterItem] = None
    filter: Optional[str] = None


class Partition(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    name: Optional[str] = ''
    description: Optional[str] = ''
    data_type: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None


class ExternalItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    location: Optional[str] = None
    file_format: Optional[str] = None
    row_format: Optional[str] = None
    tbl_properties: Optional[str] = None
    partitions: Optional[Union[List[str], List[Partition]]] = None


class Constraint9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint9]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Config8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    event_time: Optional[Any] = None


class Sources(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['source']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    source_name: str
    source_description: str
    loader: str
    identifier: str
    quoting: Optional[Quoting] = Field(None, title='Quoting')
    loaded_at_field: Optional[str] = None
    loaded_at_query: Optional[str] = None
    freshness: Optional[Freshnes1] = None
    external: Optional[ExternalItem] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns8]] = None
    meta: Optional[Dict[str, Any]] = None
    source_meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config8] = Field(None, title='SourceConfig')
    patch_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    created_at: Optional[float] = None
    unrendered_database: Optional[str] = None
    unrendered_schema: Optional[str] = None


class DependsOn9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None


class Argument(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    type: Optional[str] = None
    description: Optional[str] = ''


class SupportedLanguage(Enum):
    python = 'python'
    sql = 'sql'


class Macros(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['macro']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    macro_sql: str
    depends_on: Optional[DependsOn9] = Field(None, title='MacroDependsOn')
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    docs: Optional[Docs] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    arguments: Optional[List[Argument]] = None
    created_at: Optional[float] = None
    supported_languages: Optional[List[SupportedLanguage]] = None


class Docs18(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['doc']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    block_contents: str


class Type10(Enum):
    dashboard = 'dashboard'
    notebook = 'notebook'
    analysis = 'analysis'
    ml = 'ml'
    application = 'application'


class Owner(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    email: Optional[str] = None
    name: Optional[str] = None


class MaturityEnum(Enum):
    low = 'low'
    medium = 'medium'
    high = 'high'


class Config9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True


class DependsOn10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None
    nodes: Optional[List[str]] = None


class Exposures(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['exposure']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    type: Type10
    owner: Owner = Field(..., title='Owner')
    description: Optional[str] = ''
    label: Optional[str] = None
    maturity: Optional[MaturityEnum] = None
    meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config9] = Field(None, title='ExposureConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    url: Optional[str] = None
    depends_on: Optional[DependsOn10] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    created_at: Optional[float] = None


class Type11(Enum):
    simple = 'simple'
    ratio = 'ratio'
    cumulative = 'cumulative'
    derived = 'derived'
    conversion = 'conversion'


class WhereFilter(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_sql_template: str


class FilterItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class MeasureItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class InputMeasure(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem1] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class OffsetWindowItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: int
    granularity: str


class NumeratorItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem2] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class FilterItem3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class DenominatorItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem3] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class WindowItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: int
    granularity: str


class GrainToDateEnum(Enum):
    nanosecond = 'nanosecond'
    microsecond = 'microsecond'
    millisecond = 'millisecond'
    second = 'second'
    minute = 'minute'
    hour = 'hour'
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class FilterItem4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class Metric(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem4] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class FilterItem5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class BaseMeasure(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem5] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class ConversionMeasure(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem6] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class Calculation(Enum):
    conversions = 'conversions'
    conversion_rate = 'conversion_rate'


class ConstantProperty(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    base_property: str
    conversion_property: str


class ConversionTypeParam(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    base_measure: BaseMeasure = Field(..., title='MetricInputMeasure')
    conversion_measure: ConversionMeasure = Field(...,
                                                  title='MetricInputMeasure')
    entity: str
    calculation: Optional[Calculation] = 'conversion_rate'
    window: Optional[WindowItem] = None
    constant_properties: Optional[List[ConstantProperty]] = None


class PeriodAgg(Enum):
    first = 'first'
    last = 'last'
    average = 'average'


class CumulativeTypeParam(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    window: Optional[WindowItem] = None
    grain_to_date: Optional[str] = None
    period_agg: Optional[PeriodAgg] = 'first'


class TypeParams(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    measure: Optional[MeasureItem] = None
    input_measures: Optional[List[InputMeasure]] = None
    numerator: Optional[NumeratorItem] = None
    denominator: Optional[DenominatorItem] = None
    expr: Optional[str] = None
    window: Optional[WindowItem] = None
    grain_to_date: Optional[GrainToDateEnum] = None
    metrics: Optional[List[Metric]] = None
    conversion_type_params: Optional[ConversionTypeParam] = None
    cumulative_type_params: Optional[CumulativeTypeParam] = None


class FilterItem7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class FileSlice(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    filename: str
    content: str
    start_line_number: int
    end_line_number: int


class Metadatum(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Config10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None


class Metrics(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['metric']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    description: str
    label: str
    type: Type11
    type_params: TypeParams = Field(..., title='MetricTypeParams')
    filter: Optional[FilterItem7] = None
    metadata: Optional[Metadatum] = None
    time_granularity: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config10] = Field(None, title='MetricConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    sources: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn10] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    metrics: Optional[List[List[str]]] = None
    created_at: Optional[float] = None
    group: Optional[str] = None


class Groups(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['group']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    owner: Owner = Field(..., title='Owner')


class Docs19(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    show: Optional[bool] = True
    node_color: Optional[str] = None


class Config11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'seed'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract15] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    delimiter: Optional[str] = ','
    quote_columns: Optional[bool] = None


class Type12(Enum):
    check = 'check'
    not_null = 'not_null'
    unique = 'unique'
    primary_key = 'primary_key'
    foreign_key = 'foreign_key'
    custom = 'custom'


class Constraint10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint10]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DependsOn12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None


class ConfigItem3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract15] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem3] = None


class DisabledItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['seed']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config11] = Field(None, title='SeedConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns9]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    root_path: Optional[str] = None
    depends_on: Optional[DependsOn12] = Field(None, title='MacroDependsOn')
    defer_relation: Optional[DeferRelationItem3] = None


class Config12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract15] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint11]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DependsOn13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None
    nodes: Optional[List[str]] = None


class Contract19(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class DisabledItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['analysis']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config12] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns10]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn13] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract19] = Field(None, title='Contract')


class Config13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field('dbt_test__audit', alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'test'
    severity: Optional[Annotated[
        str,
        StringConstraints(pattern=r'^([Ww][Aa][Rr][Nn]|[Ee][Rr][Rr][Oo][Rr])$'),
    ]] = 'ERROR'
    store_failures: Optional[bool] = None
    store_failures_as: Optional[str] = None
    where: Optional[str] = None
    limit: Optional[int] = None
    fail_calc: Optional[str] = 'count(*)'
    warn_if: Optional[str] = '!= 0'
    error_if: Optional[str] = '!= 0'


class Constraint12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint12]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DisabledItem2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['test']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config13] = Field(None, title='TestConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns11]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn13] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract19] = Field(None, title='Contract')


class Contract21(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Config14(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract21] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint13]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract22(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class DisabledItem3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['operation']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config14] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns12]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn13] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract22] = Field(None, title='Contract')
    index: Optional[int] = None


class Contract23(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Config15(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract23] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    access: Optional[Access] = 'protected'


class Constraint14(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint14]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract24(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Constraint15(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None
    columns: Optional[List[str]] = None


class Contract25(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class ConfigItem4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract25] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem4] = None


class TimeSpineItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    standard_granularity_column: str
    custom_granularities: Optional[List[CustomGranularity]] = None


class DependsOn17(Enum):
    all = 'all'
    any = 'any'


class BuildAfter1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = 0
    period: Optional[Period] = 'hour'
    depends_on: Optional[DependsOn17] = 'any'


class Freshnes2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    build_after: Optional[BuildAfter1] = Field(None, title='ModelBuildAfter')


class DisabledItem4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['model']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config15] = Field(None, title='ModelConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns13]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn13] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract24] = Field(None, title='Contract')
    access: Optional[Access] = 'protected'
    constraints: Optional[List[Constraint15]] = None
    version: Optional[Union[str, float]] = None
    latest_version: Optional[Union[str, float]] = None
    deprecation_date: Optional[str] = None
    defer_relation: Optional[DeferRelationItem4] = None
    primary_key: Optional[List[str]] = None
    time_spine: Optional[TimeSpineItem1] = None
    freshness: Optional[Freshnes2] = None


class Config16(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract25] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class Constraint16(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns14(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint16]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DependsOn18(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[List[str]] = None
    nodes: Optional[List[str]] = None


class Contract27(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class DisabledItem5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['sql_operation']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config16] = Field(None, title='NodeConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns14]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract27] = Field(None, title='Contract')


class Config17(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field('dbt_test__audit', alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'test'
    severity: Optional[Annotated[
        str,
        StringConstraints(pattern=r'^([Ww][Aa][Rr][Nn]|[Ee][Rr][Rr][Oo][Rr])$'),
    ]] = 'ERROR'
    store_failures: Optional[bool] = None
    store_failures_as: Optional[str] = None
    where: Optional[str] = None
    limit: Optional[int] = None
    fail_calc: Optional[str] = 'count(*)'
    warn_if: Optional[str] = '!= 0'
    error_if: Optional[str] = '!= 0'


class Constraint17(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns15(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint17]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class DisabledItem6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['test']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Optional[Config17] = Field(None, title='TestConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns15]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract27] = Field(None, title='Contract')
    column_name: Optional[str] = None
    file_key_name: Optional[str] = None
    attached_node: Optional[str] = None
    test_metadata: Optional[TestMetadata] = Field(None, title='TestMetadata')


class Contract29(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class Config18(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'snapshot'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract29] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None
    strategy: Optional[str] = None
    target_schema: Optional[str] = None
    target_database: Optional[str] = None
    updated_at: Optional[str] = None
    check_cols: Optional[Union[str, List[str]]] = None
    snapshot_meta_column_names: Optional[SnapshotMetaColumnNames] = Field(
        None, title='SnapshotMetaColumnNames')
    dbt_valid_to_current: Optional[str] = None


class Constraint18(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns16(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint18]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Contract30(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True
    checksum: Optional[str] = None


class Contract31(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enforced: Optional[bool] = False
    alias_types: Optional[bool] = True


class ConfigItem5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    alias: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    database: Optional[str] = None
    tags: Optional[Union[List[str], str]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    materialized: Optional[str] = 'view'
    incremental_strategy: Optional[str] = None
    batch_size: Optional[Any] = None
    lookback: Optional[Any] = 1
    begin: Optional[Any] = None
    persist_docs: Optional[Dict[str, Any]] = None
    post_hook: Optional[List[PostHookItem]] = Field(None, alias='post-hook')
    pre_hook: Optional[List[PreHookItem]] = Field(None, alias='pre-hook')
    quoting: Optional[Dict[str, Any]] = None
    column_types: Optional[Dict[str, Any]] = None
    full_refresh: Optional[bool] = None
    unique_key: Optional[Union[str, List[str]]] = None
    on_schema_change: Optional[str] = 'ignore'
    on_configuration_change: Optional[OnConfigurationChange] = None
    grants: Optional[Dict[str, Any]] = None
    packages: Optional[List[str]] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    contract: Optional[Contract31] = Field(None, title='ContractConfig')
    event_time: Optional[Any] = None
    concurrent_batches: Optional[Any] = None


class DeferRelationItem5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    alias: str
    relation_name: Optional[str] = None
    resource_type: ResourceType
    name: str
    description: str
    compiled_code: Optional[str] = None
    meta: Dict[str, Any]
    tags: List[str]
    config: Optional[ConfigItem5] = None


class DisabledItem7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['snapshot']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    alias: str
    checksum: Checksum = Field(..., title='FileHash')
    config: Config18 = Field(..., title='SnapshotConfig')
    tags: Optional[List[str]] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns16]] = None
    meta: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    docs: Optional[Docs19] = Field(None, title='Docs')
    patch_path: Optional[str] = None
    build_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    created_at: Optional[float] = None
    config_call_dict: Optional[Dict[str, Any]] = None
    unrendered_config_call_dict: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    raw_code: Optional[str] = ''
    language: Optional[str] = 'sql'
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    compiled_path: Optional[str] = None
    compiled: Optional[bool] = False
    compiled_code: Optional[str] = None
    extra_ctes_injected: Optional[bool] = False
    extra_ctes: Optional[List[ExtraCte]] = None
    field_pre_injected_sql: Optional[str] = Field(None,
                                                  alias='_pre_injected_sql')
    contract: Optional[Contract30] = Field(None, title='Contract')
    defer_relation: Optional[DeferRelationItem5] = None


class WarnAfterItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = None
    period: Optional[PeriodEnum] = None


class ErrorAfterItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    count: Optional[int] = None
    period: Optional[PeriodEnum] = None


class Freshnes3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    warn_after: Optional[WarnAfterItem1] = None
    error_after: Optional[ErrorAfterItem1] = None
    filter: Optional[str] = None


class ExternalItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    location: Optional[str] = None
    file_format: Optional[str] = None
    row_format: Optional[str] = None
    tbl_properties: Optional[str] = None
    partitions: Optional[Union[List[str], List[Partition]]] = None


class Constraint19(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    type: Type12
    name: Optional[str] = None
    expression: Optional[str] = None
    warn_unenforced: Optional[bool] = True
    warn_unsupported: Optional[bool] = True
    to: Optional[str] = None
    to_columns: Optional[List[str]] = None


class Columns17(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    description: Optional[str] = ''
    meta: Optional[Dict[str, Any]] = None
    data_type: Optional[str] = None
    constraints: Optional[List[Constraint19]] = None
    quote: Optional[bool] = None
    tags: Optional[List[str]] = None
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    granularity: Optional[GranularityEnum] = None


class Config19(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    event_time: Optional[Any] = None


class DisabledItem8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    database: Optional[str] = None
    schema_: str = Field(..., alias='schema')
    name: str
    resource_type: Literal['source']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    source_name: str
    source_description: str
    loader: str
    identifier: str
    quoting: Optional[Quoting] = Field(None, title='Quoting')
    loaded_at_field: Optional[str] = None
    loaded_at_query: Optional[str] = None
    freshness: Optional[Freshnes3] = None
    external: Optional[ExternalItem1] = None
    description: Optional[str] = ''
    columns: Optional[Dict[str, Columns17]] = None
    meta: Optional[Dict[str, Any]] = None
    source_meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config19] = Field(None, title='SourceConfig')
    patch_path: Optional[str] = None
    unrendered_config: Optional[Dict[str, Any]] = None
    relation_name: Optional[str] = None
    created_at: Optional[float] = None
    unrendered_database: Optional[str] = None
    unrendered_schema: Optional[str] = None


class Type22(Enum):
    dashboard = 'dashboard'
    notebook = 'notebook'
    analysis = 'analysis'
    ml = 'ml'
    application = 'application'


class Config20(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True


class DisabledItem9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['exposure']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    type: Type22
    owner: Owner = Field(..., title='Owner')
    description: Optional[str] = ''
    label: Optional[str] = None
    maturity: Optional[MaturityEnum] = None
    meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config20] = Field(None, title='ExposureConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    url: Optional[str] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    sources: Optional[List[List[str]]] = None
    metrics: Optional[List[List[str]]] = None
    created_at: Optional[float] = None


class Type23(Enum):
    simple = 'simple'
    ratio = 'ratio'
    cumulative = 'cumulative'
    derived = 'derived'
    conversion = 'conversion'


class FilterItem8(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class MeasureItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem8] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem9(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class InputMeasure1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem9] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class NumeratorItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem10] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class FilterItem11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class DenominatorItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem11] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class FilterItem12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class Metric1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem12] = None
    alias: Optional[str] = None
    offset_window: Optional[OffsetWindowItem] = None
    offset_to_grain: Optional[str] = None


class FilterItem13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class BaseMeasure1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem13] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class FilterItem14(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class ConversionMeasure1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    filter: Optional[FilterItem14] = None
    alias: Optional[str] = None
    join_to_timespine: Optional[bool] = False
    fill_nulls_with: Optional[int] = None


class ConversionTypeParam1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    base_measure: BaseMeasure1 = Field(..., title='MetricInputMeasure')
    conversion_measure: ConversionMeasure1 = Field(...,
                                                   title='MetricInputMeasure')
    entity: str
    calculation: Optional[Calculation] = 'conversion_rate'
    window: Optional[WindowItem] = None
    constant_properties: Optional[List[ConstantProperty]] = None


class CumulativeTypeParam1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    window: Optional[WindowItem] = None
    grain_to_date: Optional[str] = None
    period_agg: Optional[PeriodAgg] = 'first'


class TypeParams1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    measure: Optional[MeasureItem1] = None
    input_measures: Optional[List[InputMeasure1]] = None
    numerator: Optional[NumeratorItem1] = None
    denominator: Optional[DenominatorItem1] = None
    expr: Optional[str] = None
    window: Optional[WindowItem] = None
    grain_to_date: Optional[GrainToDateEnum] = None
    metrics: Optional[List[Metric1]] = None
    conversion_type_params: Optional[ConversionTypeParam1] = None
    cumulative_type_params: Optional[CumulativeTypeParam1] = None


class FilterItem15(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class Metadatum1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Config21(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None


class DisabledItem10(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['metric']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    description: str
    label: str
    type: Type23
    type_params: TypeParams1 = Field(..., title='MetricTypeParams')
    filter: Optional[FilterItem15] = None
    metadata: Optional[Metadatum1] = None
    time_granularity: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None
    tags: Optional[List[str]] = None
    config: Optional[Config21] = Field(None, title='MetricConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    sources: Optional[List[List[str]]] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    metrics: Optional[List[List[str]]] = None
    created_at: Optional[float] = None
    group: Optional[str] = None


class WhereItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class QueryParams(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    metrics: List[str]
    group_by: List[str]
    where: Optional[WhereItem] = None
    order_by: Optional[List[str]] = None
    limit: Optional[int] = None


class ExportAs(Enum):
    table = 'table'
    view = 'view'


class Config22(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    export_as: ExportAs
    schema_name: Optional[str] = None
    alias: Optional[str] = None
    database: Optional[str] = None


class Export(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    config: Config22 = Field(..., title='ExportConfig')
    unrendered_config: Optional[Dict[str, str]] = None


class Metadatum2(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class ExportA(Enum):
    table = 'table'
    view = 'view'


class Cache(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    enabled: Optional[bool] = False


class Config23(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None
    export_as: Optional[ExportA] = None
    schema_: Optional[str] = Field(None, alias='schema')
    cache: Optional[Cache] = Field(None, title='SavedQueryCache')


class DisabledItem11(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['saved_query']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    query_params: QueryParams = Field(..., title='QueryParams')
    exports: List[Export]
    description: Optional[str] = None
    label: Optional[str] = None
    metadata: Optional[Metadatum2] = None
    config: Optional[Config23] = Field(None, title='SavedQueryConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    created_at: Optional[float] = None
    refs: Optional[List[Ref]] = None
    tags: Optional[Union[List[str], str]] = None


class NodeRelationItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    alias: str
    schema_name: str
    database: Optional[str] = None
    relation_name: Optional[str] = ''


class Default(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    agg_time_dimension: Optional[str] = None


class Type24(Enum):
    foreign = 'foreign'
    natural = 'natural'
    primary = 'primary'
    unique = 'unique'


class ConfigItem6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    meta: Optional[Dict[str, Any]] = None


class Entity(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    type: Type24
    description: Optional[str] = None
    label: Optional[str] = None
    role: Optional[str] = None
    expr: Optional[str] = None
    config: Optional[ConfigItem6] = None


class Agg(Enum):
    sum = 'sum'
    min = 'min'
    max = 'max'
    count_distinct = 'count_distinct'
    sum_boolean = 'sum_boolean'
    average = 'average'
    percentile = 'percentile'
    median = 'median'
    count = 'count'


class AggParam(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    percentile: Optional[float] = None
    use_discrete_percentile: Optional[bool] = False
    use_approximate_percentile: Optional[bool] = False


class WindowChoice(Enum):
    sum = 'sum'
    min = 'min'
    max = 'max'
    count_distinct = 'count_distinct'
    sum_boolean = 'sum_boolean'
    average = 'average'
    percentile = 'percentile'
    median = 'median'
    count = 'count'


class NonAdditiveDimensionItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    window_choice: WindowChoice
    window_groupings: List[str]


class Measure(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    agg: Agg
    description: Optional[str] = None
    label: Optional[str] = None
    create_metric: Optional[bool] = False
    expr: Optional[str] = None
    agg_params: Optional[AggParam] = None
    non_additive_dimension: Optional[NonAdditiveDimensionItem] = None
    agg_time_dimension: Optional[str] = None
    config: Optional[ConfigItem6] = None


class Type25(Enum):
    categorical = 'categorical'
    time = 'time'


class TimeGranularity(Enum):
    nanosecond = 'nanosecond'
    microsecond = 'microsecond'
    millisecond = 'millisecond'
    second = 'second'
    minute = 'minute'
    hour = 'hour'
    day = 'day'
    week = 'week'
    month = 'month'
    quarter = 'quarter'
    year = 'year'


class ValidityParam(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    is_start: Optional[bool] = False
    is_end: Optional[bool] = False


class TypeParam(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    time_granularity: TimeGranularity
    validity_params: Optional[ValidityParam] = None


class Metadatum3(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Dimension(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    type: Type25
    description: Optional[str] = None
    label: Optional[str] = None
    is_partition: Optional[bool] = False
    type_params: Optional[TypeParam] = None
    expr: Optional[str] = None
    metadata: Optional[Metadatum3] = None
    config: Optional[ConfigItem6] = None


class Metadatum4(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Config24(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None


class DisabledItem12(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: ResourceType
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    model: str
    node_relation: Optional[NodeRelationItem] = None
    description: Optional[str] = None
    label: Optional[str] = None
    defaults: Optional[Default] = None
    entities: Optional[List[Entity]] = None
    measures: Optional[List[Measure]] = None
    dimensions: Optional[List[Dimension]] = None
    metadata: Optional[Metadatum4] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    created_at: Optional[float] = None
    config: Optional[Config24] = Field(None, title='SemanticModelConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    primary_entity: Optional[str] = None
    group: Optional[str] = None


class Format(Enum):
    csv = 'csv'
    dict = 'dict'
    sql = 'sql'


class GivenItem(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    input: str
    rows: Optional[Union[str, List[Dict[str, Any]]]] = None
    format: Optional[Format] = 'dict'
    fixture: Optional[str] = None


class Expect(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    rows: Optional[Union[str, List[Dict[str, Any]]]] = None
    format: Optional[Format] = 'dict'
    fixture: Optional[str] = None


class Override(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    macros: Optional[Dict[str, Any]] = None
    vars: Optional[Dict[str, Any]] = None
    env_vars: Optional[Dict[str, Any]] = None


class Config25(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    tags: Optional[Union[str, List[str]]] = None
    meta: Optional[Dict[str, Any]] = None
    enabled: Optional[bool] = True


class Version(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    include: Optional[List[Union[str, float]]] = None
    exclude: Optional[List[Union[str, float]]] = None


class DisabledItem13(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    model: str
    given: List[GivenItem]
    expect: Expect = Field(..., title='UnitTestOutputFixture')
    name: str
    resource_type: ResourceType
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    description: Optional[str] = ''
    overrides: Optional[Override] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    config: Optional[Config25] = Field(None, title='UnitTestConfig')
    checksum: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    created_at: Optional[float] = None
    versions: Optional[Version] = None
    version: Optional[Union[str, float]] = None


class WhereItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    where_filters: List[WhereFilter]


class QueryParams1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    metrics: List[str]
    group_by: List[str]
    where: Optional[WhereItem1] = None
    order_by: Optional[List[str]] = None
    limit: Optional[int] = None


class Config26(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    export_as: ExportAs
    schema_name: Optional[str] = None
    alias: Optional[str] = None
    database: Optional[str] = None


class Export1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    config: Config26 = Field(..., title='ExportConfig')
    unrendered_config: Optional[Dict[str, str]] = None


class Metadatum5(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Config27(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None
    export_as: Optional[ExportA] = None
    schema_: Optional[str] = Field(None, alias='schema')
    cache: Optional[Cache] = Field(None, title='SavedQueryCache')


class SavedQueries(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: Literal['saved_query']
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    query_params: QueryParams1 = Field(..., title='QueryParams')
    exports: List[Export1]
    description: Optional[str] = None
    label: Optional[str] = None
    metadata: Optional[Metadatum5] = None
    config: Optional[Config27] = Field(None, title='SavedQueryConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    group: Optional[str] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    created_at: Optional[float] = None
    refs: Optional[List[Ref]] = None
    tags: Optional[Union[List[str], str]] = None


class Type26(Enum):
    foreign = 'foreign'
    natural = 'natural'
    primary = 'primary'
    unique = 'unique'


class Entity1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    type: Type26
    description: Optional[str] = None
    label: Optional[str] = None
    role: Optional[str] = None
    expr: Optional[str] = None
    config: Optional[ConfigItem6] = None


class NonAdditiveDimensionItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    window_choice: WindowChoice
    window_groupings: List[str]


class Measure1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    agg: Agg
    description: Optional[str] = None
    label: Optional[str] = None
    create_metric: Optional[bool] = False
    expr: Optional[str] = None
    agg_params: Optional[AggParam] = None
    non_additive_dimension: Optional[NonAdditiveDimensionItem1] = None
    agg_time_dimension: Optional[str] = None
    config: Optional[ConfigItem6] = None


class Type27(Enum):
    categorical = 'categorical'
    time = 'time'


class TypeParam1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    time_granularity: TimeGranularity
    validity_params: Optional[ValidityParam] = None


class Metadatum6(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Dimension1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    type: Type27
    description: Optional[str] = None
    label: Optional[str] = None
    is_partition: Optional[bool] = False
    type_params: Optional[TypeParam1] = None
    expr: Optional[str] = None
    metadata: Optional[Metadatum6] = None
    config: Optional[ConfigItem6] = None


class Metadatum7(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    repo_file_path: str
    file_slice: FileSlice = Field(..., title='FileSlice')


class Config28(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    enabled: Optional[bool] = True
    group: Optional[str] = None
    meta: Optional[Dict[str, Any]] = None


class SemanticModels(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    name: str
    resource_type: ResourceType
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    model: str
    node_relation: Optional[NodeRelationItem] = None
    description: Optional[str] = None
    label: Optional[str] = None
    defaults: Optional[Default] = None
    entities: Optional[List[Entity1]] = None
    measures: Optional[List[Measure1]] = None
    dimensions: Optional[List[Dimension1]] = None
    metadata: Optional[Metadatum7] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    refs: Optional[List[Ref]] = None
    created_at: Optional[float] = None
    config: Optional[Config28] = Field(None, title='SemanticModelConfig')
    unrendered_config: Optional[Dict[str, Any]] = None
    primary_entity: Optional[str] = None
    group: Optional[str] = None


class GivenItem1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    input: str
    rows: Optional[Union[str, List[Dict[str, Any]]]] = None
    format: Optional[Format] = 'dict'
    fixture: Optional[str] = None


class Expect1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    rows: Optional[Union[str, List[Dict[str, Any]]]] = None
    format: Optional[Format] = 'dict'
    fixture: Optional[str] = None


class Config29(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    field_extra: Optional[Dict[str, Any]] = Field(None, alias='_extra')
    tags: Optional[Union[str, List[str]]] = None
    meta: Optional[Dict[str, Any]] = None
    enabled: Optional[bool] = True


class UnitTests(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    model: str
    given: List[GivenItem1]
    expect: Expect1 = Field(..., title='UnitTestOutputFixture')
    name: str
    resource_type: ResourceType
    package_name: str
    path: str
    original_file_path: str
    unique_id: str
    fqn: List[str]
    description: Optional[str] = ''
    overrides: Optional[Override] = None
    depends_on: Optional[DependsOn18] = Field(None, title='DependsOn')
    config: Optional[Config29] = Field(None, title='UnitTestConfig')
    checksum: Optional[str] = None
    schema_: Optional[str] = Field(None, alias='schema')
    created_at: Optional[float] = None
    versions: Optional[Version] = None
    version: Optional[Union[str, float]] = None


class ManifestCLOUDV1(BaseParserModel):
    model_config = ConfigDict(extra='allow',)
    metadata: Metadata = Field(...,
                               description='Metadata about the manifest',
                               title='ManifestMetadata')
    nodes: Dict[str, Union[
        Node, Node1, Node2, Node3, Node4, Node5, Node6, Node7]] = Field(
            ...,
            description=
            'The nodes defined in the dbt project and its dependencies')
    sources: Dict[str, Sources] = Field(
        ...,
        description='The sources defined in the dbt project and its dependencies'
    )
    macros: Dict[str, Macros] = Field(
        ...,
        description='The macros defined in the dbt project and its dependencies'
    )
    docs: Dict[str, Docs18] = Field(
        ...,
        description='The docs defined in the dbt project and its dependencies')
    exposures: Dict[str, Exposures] = Field(
        ...,
        description=
        'The exposures defined in the dbt project and its dependencies')
    metrics: Dict[str, Metrics] = Field(
        ...,
        description='The metrics defined in the dbt project and its dependencies'
    )
    groups: Dict[str, Groups] = Field(
        ..., description='The groups defined in the dbt project')
    selectors: Dict[str, Any] = Field(
        ..., description='The selectors defined in selectors.yml')
    disabled: Optional[Dict[
        str,
        List[Union[
            DisabledItem,
            DisabledItem1,
            DisabledItem2,
            DisabledItem3,
            DisabledItem4,
            DisabledItem5,
            DisabledItem6,
            DisabledItem7,
            DisabledItem8,
            DisabledItem9,
            DisabledItem10,
            DisabledItem11,
            DisabledItem12,
            DisabledItem13,
        ]],
    ]] = Field(..., description='A mapping of the disabled nodes in the target')
    parent_map: Optional[Dict[str, List[str]]] = Field(
        ..., description='A mapping from\xa0child nodes to their dependencies')
    child_map: Optional[Dict[str, List[str]]] = Field(
        ..., description='A mapping from parent nodes to their dependents')
    group_map: Optional[Dict[str, List[str]]] = Field(
        ..., description='A mapping from group names to their nodes')
    saved_queries: Dict[str, SavedQueries] = Field(
        ..., description='The saved queries defined in the dbt project')
    semantic_models: Dict[str, SemanticModels] = Field(
        ..., description='The semantic models defined in the dbt project')
    unit_tests: Dict[str, UnitTests] = Field(
        ..., description='The unit tests defined in the project')
